var/global/world_speed
var/cpu_readings
var/cpu_total
var/cpu_average
var/spit = 0
player
	icon = 'gfx/mob.dmi'
	icon_state = "player"

	parent_type = /mob
	speed = 5

	var/tmp/north, south, east, west

	Stat()
		stat("cpu", world.cpu)
		cpu_readings++
		cpu_total += world.cpu
		cpu_average = cpu_total/cpu_readings
		stat("cpu average", cpu_average)
		stat("projectiles", projectiles)
		stat("projectiles_fired", projectiles_fired)
		//stat("extra speed", world_speed)
		stat("bots", bots)

		//spits out performance results after 100k projectiles fired
		if(projectiles_fired >= 100000 && !spit)
			spit = 1
			world << "cpu: [world.cpu]"
			world << "cpu_average: [cpu_average]"
			world << "projectiles: [projectiles]"
			world << "projectiles_fired: [projectiles_fired]"
			world << "bots: [bots]"


	Login()
		..()
		src.client.add_keys()
		src.client.set_focus(src)

		spawn movement_loop()

		loc = locate(64,1,1)

	key_down(k, client/c)
		..()

	verb/say(t as text)
		world << "[src]: [t]"

	proc/movement_loop()
		while(src)
			if(world.time >= move_time && client)
				if(client.keys["w"] || client.keys["north"]) north = 1
				else north = 0
				if(client.keys["s"] || client.keys["south"]) south = 1
				else south = 0
				if(client.keys["a"] || client.keys["west"]) west = 1
				else west = 0
				if(client.keys["d"] || client.keys["east"]) east = 1
				else east = 0

				if(north && south)
					north = 0
					south = 0
				if(west && east)
					west = 0
					east = 0

				var/dirs = (north && NORTH) | (south && SOUTH) | (east && EAST) | (west && WEST)

				if(!step(src, dirs))
					if(!step(src, dirs & (NORTH | SOUTH)))
						step(src, dirs & (EAST | WEST))
			sleep(world.tick_lag)

		//spawn(world.tick_lag) movement_loop()